clear all; close all;
%
N=1024; K=200;
%KrOut=0.2; KrIn=0.2;                % noises
KrOut=0.1; KrIn=0.0;                % noises
% regularization constants
lamb1=1.5;   % DC
lamb2=100;   % norm
lamb3=1000;  % norm
%
junit=-sqrt(-1); pi2j=2*pi*junit;
nfreq1=fix(N/2-1); 
%nfreq1=fix(N/10); 
n1=N/2; fv1=[1:nfreq1]'; fvo1=[1:2:nfreq1]'; 
%--------
S=zeros(N,1);
S(fvo1) = ones(size(fvo1)).* exp(sqrt(-1)*2*pi*rand(size(fvo1)));
Signal = 2*real(ifft(S));
u0 = Signal/std(Signal); u0=[u0; u0; u0; u0];
%------------------------
[bcoeff,acoeff]=butter(1,0.02); 
y0=filter(bcoeff,acoeff,u0); 
figure(1), subplot(211), plot(u0(1:N)); grid;  title('Input');
subplot(212), plot(y0(1:N)); grid; title('Output (1st order, LowPass Butterworth');
%pause;

%-noisy measurement ------------
um=u0+KrIn*randn(size(u0));
%- measurement matrix ----------
%u=u0(1+K:N+K); ur=u0(1+K:-1:1);     % for full H matrix
u=um(1:N); ur=[um(1) zeros(1,K)];  % for triangular H matrix
H=toeplitz(u,ur);

%- matrices for regularization -------------
YY=zeros(1+K,1+K);
for i=1:1+K, for j=1:1+K, YY(i,j)=(.9^abs(i-j))*exp(-.02*(i+j)); end; end;
EE1=lamb1*inv(YY); 
EE2=lamb2*eye(1+K);
EE3=lamb3*eye(1+K);

%-- noisy measurement -------------
ym=y0+KrOut*randn(size(y0));
%y1=y0(1+K:N+K); y2=ym(1+K:N+K);     % for full H matrix
y1=y0(1:N); y2=ym(1:N);            % for triangular H matrix
%
figure(2), subplot(211), plot([u0(1:N) um(1:N)]); grid;  title('Measured Input');
subplot(212), plot([y0(1:N) ym(1:N)]); grid; title('Measured Output');
%pause;
%
%-- estimates --------------------
gpls=inv(H'*H)*H'*y1; 
gnls=inv(H'*H)*H'*y2; 
gnlsr1=inv(H'*H+EE1)*H'*y2;
gnlsr2=inv(H'*H+EE2)*H'*y2;
gnlsr3=inv(H'*H+EE3)*H'*y2;

%-------------------------------
figure(3), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); hold off;
title('Impulse Response Estimate k(noiseless LS), r(noisy LS)'); 
%pause;
%--------------------------
figure(4), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); stem(gnlsr2,'g'); hold off;
title('Impulse Response Estimate k(noiseless LS), r(noisy LS), g(regularized by norm)'); 
%pause;
%--------------------------
figure(5), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); stem(gnlsr3,'g'); hold off;
title('Impulse Response Estimate k(noiseless LS), r(noisy LS), g(regularized by norm)'); 
%pause;
%----------------
figure(6), stem(gpls,'k'); grid; hold on; 
stem(gnls,'r'); stem(gnlsr1,'b'); hold off;
title('Impulse Response Estimate k(noiseless LS), r(noisy LS), g(regularized by corr)'); 

